//+------------------------------------------------------------------+ 
//|                MTF_SuperTrend2.mq4         www.forex-tsd.com   ik|
//|                   Copyright  2005, Jason Robinson (jnrtrading). |
//|                                      http://www.jnrtrading.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Jason Robinson (jnrtrading)."
#property link      "http://www.jnrtrading.co.uk"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 LimeGreen
#property indicator_color2 Red
#property indicator_color3 Goldenrod
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 2
//---- input parameters 
extern int TimeFrame=0;

extern int NbPeriods = 10;
extern int  Shift=0;  
extern bool Display_SuperTrend = true;
extern bool Display_Average_Price_Line = true;
extern bool Automatic_Timeframe_Settings = false;

extern int M1_NbPeriods = 10;
extern int M5_NbPeriods = 10;
extern int M15_NbPeriods = 10;
extern int M30_NbPeriods = 10;
extern int H1_NbPeriods = 10;
extern int H4_NbPeriods = 10;
extern int D1_NbPeriods = 10;
extern int W1_NbPeriods = 10; 
extern int MN_NbPeriods = 10;

double TrendUp[], TrendDown[], Price1[], Price2[], AvgPrice[], Trend[];
int UpDownShift;
double price1, price2;


//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
---------------------------------------
PRICE_CLOSE    0 Close price. 
PRICE_OPEN     1 Open price. 
PRICE_HIGH     2 High price. 
PRICE_LOW      3 Low price. 
PRICE_MEDIAN   4 Median price, (high+low)/2. 
PRICE_TYPICAL  5 Typical price, (high+low+close)/3. 
PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4. 
You must use the numeric value of the Applied Price that you want to use
when you set the 'applied_price' value with the indicator inputs.
---------------------------------------
MODE_SMA    0 Simple moving average, 
MODE_EMA    1 Exponential moving average, 
MODE_SMMA   2 Smoothed moving average, 
MODE_LWMA   3 Linear weighted moving average. 
You must use the numeric value of the MA Method that you want to use
when you set the 'ma_method' value with the indicator inputs.

**************************************************************************/
//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init() 
{ 
   IndicatorBuffers(6);
   SetIndexBuffer(0, TrendUp);
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID);
   SetIndexBuffer(1, TrendDown);
   SetIndexStyle(1, DRAW_LINE, STYLE_SOLID);
   SetIndexBuffer(2, AvgPrice);
   SetIndexStyle(2, DRAW_LINE, STYLE_SOLID);
   SetIndexBuffer(3, Price1);
   SetIndexBuffer(4, Price2);
   SetIndexBuffer(5, Trend);
     if(TimeFrame==0) TimeFrame = Period();
   SetIndexShift(0, Shift*TimeFrame/Period());
   SetIndexShift(1, Shift*TimeFrame/Period());
   SetIndexShift(2, Shift*TimeFrame/Period());   
     SetIndexLabel(0,"MTF_ST2("+NbPeriods+")TrendUp,TF"+TimeFrame+"s"+Shift+"");
     SetIndexLabel(1,"MTF_ST2("+NbPeriods+")TrendDn,TF"+TimeFrame+"s"+Shift+"");
     SetIndexLabel(2,"MTF_ST2("+NbPeriods+")AvgPrice,TF"+TimeFrame+"s"+Shift+"");

//---- name for DataWindow and indicator subwindow label
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }
    IndicatorShortName("MTF_Super_Trend2");  
  }
//----
   return(0);
 
//+------------------------------------------------------------------+
//| MTF                                            |
//+------------------------------------------------------------------+
int start()
 
  {  
   datetime TimeArray[];
   int    i,shift,limit,y=0,counted_bars=IndicatorCounted();
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   limit=Bars-counted_bars+TimeFrame/Period();
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++; 
  
 /***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator timeframe
   Rule 3:  Use 'y' for the indicator's shift value
 **********************************************************/  
    
   TrendUp[i]=iCustom(NULL,TimeFrame,"Super_Trend2",NbPeriods,0,y);
   TrendDown[i]=iCustom(NULL,TimeFrame,"Super_Trend2",NbPeriods,1,y);
   AvgPrice[i]=iCustom(NULL,TimeFrame,"Super_Trend2",NbPeriods,2,y);
   Price1[i]=iCustom(NULL,TimeFrame,"Super_Trend2",NbPeriods,3,y);
   Price2[i]=iCustom(NULL,TimeFrame,"Super_Trend2",NbPeriods,4,y);
   Trend[i]=iCustom(NULL,TimeFrame,"Super_Trend2",NbPeriods,5,y);

   }  
   return(0);
  }
//---

